<?php
/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog 1.3.8x
// +---------------------------------------------------------------------------+
// | group_admin.php                                                           |
// |                                                                           |
// | Geeklog user group bulk administration page.  Use this script to assign   |
// | Geeklog secuirty groups to all users.                                     |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2000-2003 by the following authors:                         |
// |                                                                           |
// | Authors: Danny Ledger        - danny@squatty.com                          |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');
require_once('auth.inc.php');

$display = '';

// Make sure user has access to this page
if (!SEC_hasRights('user.edit')) {
    $retval .= COM_siteHeader ('menu');
    $retval .= COM_startBlock ($MESSAGE[30], '',
               COM_getBlockTemplate ('_msg_block', 'header'));
    $retval .= $MESSAGE[37];
    $retval .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $retval .= COM_siteFooter ();
    COM_errorLog("User {$_USER['username']} tried to illegally access the bulk user group administration screen",1);
    echo $retval;
    exit;
}

/**
* Loops through the users and updates groups assignments
*
* @grp_id      int         Group to assign
*
*/
function edituser($grp_id)
{
    global $_TABLES, $_CONF, $_USER, $grp_id;
	
    
    //echo $grp_id;

    if ($grp_id>0){

    	$sql = "SELECT uid FROM {$_TABLES['users']}";
  	$result = DB_query($sql);
	$nrows = DB_numRows($result);

	  for ($i = 0; $i < $nrows; $i++) {
	 	  $A = DB_fetchArray($result);
                  //echo $A['uid'];
		  $uid = $A['uid'];	
		  $sql = "SELECT ug_uid, ug_main_grp_id  FROM {$_TABLES['group_assignments']} WHERE ug_uid=$uid AND ug_main_grp_id=$grp_id";
		  $row = DB_fetchArray(DB_query($sql));
		  $match = $row['ug_main_grp_id'];
		  
		  //echo $sql;	
	 	  //echo "<br>User ID is: ";
		  //echo $A['uid'];		 
		  //echo "<br>User status is: ";		  
		
		  if (!$match){
			//echo "I'm not in this group";
			DB_query("INSERT INTO {$_TABLES['group_assignments']} (ug_main_grp_id, ug_uid) VALUES($grp_id, $uid)");
		  } else {
			//echo "I'm in this group";
                  }
		 //echo "<br><br>";
	 	  
	 }
         $retval .= '<b>Group Update Complete</b><p>';
	 $retval .= display_form();

	 
    } else {
	$retval .= '<b>You did not select a group!  Try again.</b><p>';
	$retval .= display_form();
    }
    return $retval;
}

/**
* Displays the group assignment form
*
*/
function display_form()
{
    global $_CONF, $_TABLES;
    
    $sql = "SELECT grp_id, grp_name FROM {$_TABLES['groups']} ORDER BY grp_name";
    $query = DB_query($sql);
    $retval .= 'Select a group to assign to <b><I>ALL</b></I> users.<P>';
    $retval .= '<form action="' . $_CONF['site_admin_url'] . '/group_admin.php" method="post">'
            . '<input type="hidden" name="mode" value="edit">';
    $retval .= 'Group:'
            . '&nbsp;&nbsp;<select name="grp_id">'
            . '<option selected>'
            . '--Select a Group--'
            . '</option>';
    while ($row = DB_fetchArray($query)) {	      
              $retval .= '<option value="'.$row['grp_id'].'">'.$row['grp_name'].'</option>';	      
    }
    $retval .= '</select>'
            . '&nbsp;&nbsp;<input type="submit" name="submit" value="Submit"></form>';
    
    
    return $retval;
}

// MAIN
if ($mode == 'edit') {    
    $display .= COM_siteHeader('menu'); 
    $display .= COM_startBlock('Bulk User Group Administration');   
    $display .= edituser($grp_id);    	
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
} else if ($mode == '') {
    $display .= COM_siteHeader('menu');
    $display .= COM_startBlock('Bulk User Group Administration');	
    $display .= display_form();
    $display .= COM_endBlock();
    $display .= COM_siteFooter();	        
}

echo $display;

?>
